
{% for vhost in application_nginx_proxy %}
server {
        listen 80;
        listen [::]:80;

{% if vhost.domains is defined %}
{% for server in vhost.domains %}
        server_name {{ server }};
{% endfor %}
{% endif %}

        server_tokens off;
        include proxy.include;
{% for header in vhost.headers %}
        add_header {{ header }};
{% endfor %}

{% if vhost.ssl_force == true %}
        if ($scheme = http) {
                return 301 https://{{ vhost.ssl_domain }}$request_uri;
        }
{% endif %}

{% if letsencrypt %}
        include acme.include;
{% endif %}

{% if vhost.ssl is defined %}
        listen 443 ssl;
        listen [::]:443 ssl;

        ssl_certificate {{ vhost.ssl.cert_path }};
        ssl_certificate_key {{ vhost.ssl.key_path }};

        ssl_session_timeout  5m;

        ssl_protocols  SSLv2 TLSv1 TLSv1.1 TLSv1.2;
        ssl_ciphers "EECDH+ECDSA+AESGCM EECDH+aRSA+AESGCM EECDH+ECDSA+SHA384 EECDH+ECDSA+SHA256 EECDH+aRSA+SHA384 EECDH+aRSA+SHA256 EECDH+aRSA+RC4 EECDH EDH+aRSA !RC4 !aNULL !eNULL !LOW !3DES !MD5 !EXP !PSK !SRP !DSS";
        ssl_prefer_server_ciphers   on;
{% endif %}

        location / {
{% if vhost.cors_hack == true %}
        	if ($request_method = OPTIONS ) {
                	add_header Cache-Control "private,max-age=600";
	                add_header Access-Control-Allow-Origin "*";
	                add_header Access-Control-Allow-Methods "GET,POST,PUT,DELETE,HEAD,OPTIONS,PATCH";
        	        add_header Access-Control-Allow-Headers "Content-Type,X-Requested-With,Authorization,If-Modified-Since";
	                return 200;
	        }
{% endif %}

                proxy_pass http://{{ vhost.backend_name }}:{{ vhost.backend_port }};
        }
        access_log  /var/log/nginx/{{ vhost.name }}.access.log;
        error_log /var/log/nginx/{{ vhost.name }}.error.log;

}

{% endfor %}
